/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the RecordSetListResult class.
 * @constructor
 * The response to a RecordSet List operation.
 * @member {array} [value] Gets or sets information about the RecordSets in
 * the response.
 * 
 * @member {string} [nextLink] Gets or sets the continuation token for the
 * next page.
 * 
 */
function RecordSetListResult() {
}

util.inherits(RecordSetListResult, Array);

/**
 * Defines the metadata of RecordSetListResult
 *
 * @returns {object} metadata of RecordSetListResult
 *
 */
RecordSetListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'RecordSetListResult',
    type: {
      name: 'Composite',
      className: 'RecordSetListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'RecordSetElementType',
                type: {
                  name: 'Composite',
                  className: 'RecordSet'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = RecordSetListResult;
