/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the SoaRecord class.
 * @constructor
 * An SOA record.
 * @member {string} [host] Gets or sets the domain name of the authoritative
 * name server, without a temrinating dot.
 * 
 * @member {string} [email] Gets or sets the email for this record.
 * 
 * @member {number} [serialNumber] Gets or sets the serial number for this
 * record.
 * 
 * @member {number} [refreshTime] Gets or sets the refresh value for this
 * record.
 * 
 * @member {number} [retryTime] Gets or sets the retry time for this record.
 * 
 * @member {number} [expireTime] Gets or sets the expire time for this record.
 * 
 * @member {number} [minimumTtl] Gets or sets the minimum TTL value for this
 * record.
 * 
 */
function SoaRecord() {
}

/**
 * Defines the metadata of SoaRecord
 *
 * @returns {object} metadata of SoaRecord
 *
 */
SoaRecord.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SoaRecord',
    type: {
      name: 'Composite',
      className: 'SoaRecord',
      modelProperties: {
        host: {
          required: false,
          serializedName: 'host',
          type: {
            name: 'String'
          }
        },
        email: {
          required: false,
          serializedName: 'email',
          type: {
            name: 'String'
          }
        },
        serialNumber: {
          required: false,
          serializedName: 'serialNumber',
          type: {
            name: 'Number'
          }
        },
        refreshTime: {
          required: false,
          serializedName: 'refreshTime',
          type: {
            name: 'Number'
          }
        },
        retryTime: {
          required: false,
          serializedName: 'retryTime',
          type: {
            name: 'Number'
          }
        },
        expireTime: {
          required: false,
          serializedName: 'expireTime',
          type: {
            name: 'Number'
          }
        },
        minimumTtl: {
          required: false,
          serializedName: 'minimumTTL',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = SoaRecord;
