/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the SrvRecord class.
 * @constructor
 * An SRV record.
 * @member {number} [priority] Gets or sets the priority metric for this
 * record.
 * 
 * @member {number} [weight] Gets or sets the weight metric for this this
 * record.
 * 
 * @member {number} [port] Gets or sets the port of the service for this
 * record.
 * 
 * @member {string} [target] Gets or sets the domain name of the target for
 * this record, without a terminating dot.
 * 
 */
function SrvRecord() {
}

/**
 * Defines the metadata of SrvRecord
 *
 * @returns {object} metadata of SrvRecord
 *
 */
SrvRecord.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SrvRecord',
    type: {
      name: 'Composite',
      className: 'SrvRecord',
      modelProperties: {
        priority: {
          required: false,
          serializedName: 'priority',
          type: {
            name: 'Number'
          }
        },
        weight: {
          required: false,
          serializedName: 'weight',
          type: {
            name: 'Number'
          }
        },
        port: {
          required: false,
          serializedName: 'port',
          type: {
            name: 'Number'
          }
        },
        target: {
          required: false,
          serializedName: 'target',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = SrvRecord;
