/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ZoneListResult class.
 * @constructor
 * The response to a Zone List or ListAll operation.
 * @member {array} [value] Gets or sets information about the zones in the
 * response.
 * 
 * @member {string} [nextLink] Gets or sets the continuation token for the
 * next page.
 * 
 */
function ZoneListResult() {
}

util.inherits(ZoneListResult, Array);

/**
 * Defines the metadata of ZoneListResult
 *
 * @returns {object} metadata of ZoneListResult
 *
 */
ZoneListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ZoneListResult',
    type: {
      name: 'Composite',
      className: 'ZoneListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'ZoneElementType',
                type: {
                  name: 'Composite',
                  className: 'Zone'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ZoneListResult;
