/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the CloudToDeviceProperties class.
 * @constructor
 * The Iot Hub Cloud-To-Device messaging properties.
 * @member {number} [maxDeliveryCount] The max delivery count for the device
 * queue. Range : 1-100.
 * 
 * @member {moment.duration} [defaultTtlAsIso8601] The default time to live
 * for the device queue. Range : 1 Min (PT1M) - 2 Days (P2D).
 * 
 * @member {object} [feedback]
 * 
 * @member {moment.duration} [feedback.lockDurationAsIso8601] The lock
 * duration for the feedback queue. Range: 5 Sec (PT5S) - 5 Min (PT5M).
 * 
 * @member {moment.duration} [feedback.ttlAsIso8601] The time to live for the
 * feedback queue. Range: 1 Min (PT1M) - 2 Days (P2D).
 * 
 * @member {number} [feedback.maxDeliveryCount] The max delivery count. Range
 * : 1-100.
 * 
 */
function CloudToDeviceProperties() {
}

/**
 * Defines the metadata of CloudToDeviceProperties
 *
 * @returns {object} metadata of CloudToDeviceProperties
 *
 */
CloudToDeviceProperties.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'CloudToDeviceProperties',
    type: {
      name: 'Composite',
      className: 'CloudToDeviceProperties',
      modelProperties: {
        maxDeliveryCount: {
          required: false,
          serializedName: 'maxDeliveryCount',
          constraints: {
            InclusiveMaximum: 100,
            InclusiveMinimum: 1
          },
          type: {
            name: 'Number'
          }
        },
        defaultTtlAsIso8601: {
          required: false,
          serializedName: 'defaultTtlAsIso8601',
          type: {
            name: 'TimeSpan'
          }
        },
        feedback: {
          required: false,
          serializedName: 'feedback',
          type: {
            name: 'Composite',
            className: 'FeedbackProperties'
          }
        }
      }
    }
  };
};

module.exports = CloudToDeviceProperties;
