/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ErrorDetails class.
 * @constructor
 * The properties related to the details of an error.
 * @member {string} [code] The error code.
 * 
 * @member {string} [httpStatusCode] The http status code.
 * 
 * @member {string} [message] The error message.
 * 
 * @member {string} [details] The error details.
 * 
 */
function ErrorDetails() {
}

/**
 * Defines the metadata of ErrorDetails
 *
 * @returns {object} metadata of ErrorDetails
 *
 */
ErrorDetails.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ErrorDetails',
    type: {
      name: 'Composite',
      className: 'ErrorDetails',
      modelProperties: {
        code: {
          required: false,
          serializedName: 'Code',
          type: {
            name: 'String'
          }
        },
        httpStatusCode: {
          required: false,
          readOnly: true,
          serializedName: 'HttpStatusCode',
          type: {
            name: 'String'
          }
        },
        message: {
          required: false,
          serializedName: 'Message',
          type: {
            name: 'String'
          }
        },
        details: {
          required: false,
          serializedName: 'Details',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ErrorDetails;
