/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the EventHubConsumerGroupsListResult class.
 * @constructor
 * The list of eventhub consumer group names with a next link.
 * @member {array} [value] The list of eventhub consumer group names.
 * 
 * @member {string} [nextLink] The next link.
 * 
 */
function EventHubConsumerGroupsListResult() {
}

util.inherits(EventHubConsumerGroupsListResult, Array);

/**
 * Defines the metadata of EventHubConsumerGroupsListResult
 *
 * @returns {object} metadata of EventHubConsumerGroupsListResult
 *
 */
EventHubConsumerGroupsListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'EventHubConsumerGroupsListResult',
    type: {
      name: 'Composite',
      className: 'EventHubConsumerGroupsListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        nextLink: {
          required: false,
          readOnly: true,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = EventHubConsumerGroupsListResult;
