/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ExportDevicesRequest class.
 * @constructor
 * Used to provide parameters when requesting an export of all devices in the
 * hub.
 * @member {string} exportBlobContainerUri The export BLOB container URI.
 * 
 * @member {boolean} excludeKeys The value indicating whether keys should be
 * excluded during export.
 * 
 */
function ExportDevicesRequest() {
}

/**
 * Defines the metadata of ExportDevicesRequest
 *
 * @returns {object} metadata of ExportDevicesRequest
 *
 */
ExportDevicesRequest.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ExportDevicesRequest',
    type: {
      name: 'Composite',
      className: 'ExportDevicesRequest',
      modelProperties: {
        exportBlobContainerUri: {
          required: true,
          serializedName: 'ExportBlobContainerUri',
          type: {
            name: 'String'
          }
        },
        excludeKeys: {
          required: true,
          serializedName: 'ExcludeKeys',
          type: {
            name: 'Boolean'
          }
        }
      }
    }
  };
};

module.exports = ExportDevicesRequest;
