/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the FeedbackProperties class.
 * @constructor
 * The Feedback Queue properties.
 * @member {moment.duration} [lockDurationAsIso8601] The lock duration for the
 * feedback queue. Range: 5 Sec (PT5S) - 5 Min (PT5M).
 * 
 * @member {moment.duration} [ttlAsIso8601] The time to live for the feedback
 * queue. Range: 1 Min (PT1M) - 2 Days (P2D).
 * 
 * @member {number} [maxDeliveryCount] The max delivery count. Range : 1-100.
 * 
 */
function FeedbackProperties() {
}

/**
 * Defines the metadata of FeedbackProperties
 *
 * @returns {object} metadata of FeedbackProperties
 *
 */
FeedbackProperties.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'FeedbackProperties',
    type: {
      name: 'Composite',
      className: 'FeedbackProperties',
      modelProperties: {
        lockDurationAsIso8601: {
          required: false,
          serializedName: 'lockDurationAsIso8601',
          type: {
            name: 'TimeSpan'
          }
        },
        ttlAsIso8601: {
          required: false,
          serializedName: 'ttlAsIso8601',
          type: {
            name: 'TimeSpan'
          }
        },
        maxDeliveryCount: {
          required: false,
          serializedName: 'maxDeliveryCount',
          constraints: {
            InclusiveMaximum: 100,
            InclusiveMinimum: 1
          },
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = FeedbackProperties;
