/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ImportDevicesRequest class.
 * @constructor
 * Used to provide parameters when requesting an import of all devices in the
 * hub.
 * @member {string} inputBlobContainerUri The input BLOB container URI.
 * 
 * @member {string} outputBlobContainerUri The output BLOB container URI.
 * 
 */
function ImportDevicesRequest() {
}

/**
 * Defines the metadata of ImportDevicesRequest
 *
 * @returns {object} metadata of ImportDevicesRequest
 *
 */
ImportDevicesRequest.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ImportDevicesRequest',
    type: {
      name: 'Composite',
      className: 'ImportDevicesRequest',
      modelProperties: {
        inputBlobContainerUri: {
          required: true,
          serializedName: 'InputBlobContainerUri',
          type: {
            name: 'String'
          }
        },
        outputBlobContainerUri: {
          required: true,
          serializedName: 'OutputBlobContainerUri',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ImportDevicesRequest;
