/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the IotHubCapacity class.
 * @constructor
 * The properties related to the capacity information.
 * @member {number} [minimum] The minimum number of units.
 * 
 * @member {number} [maximum] The maximum number of units.
 * 
 * @member {number} [default] The default number of units.
 * 
 * @member {string} [scaleType] The type of the scale. Possible values
 * include: 'Automatic', 'Manual', 'None'
 * 
 */
function IotHubCapacity() {
}

/**
 * Defines the metadata of IotHubCapacity
 *
 * @returns {object} metadata of IotHubCapacity
 *
 */
IotHubCapacity.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'IotHubCapacity',
    type: {
      name: 'Composite',
      className: 'IotHubCapacity',
      modelProperties: {
        minimum: {
          required: false,
          serializedName: 'minimum',
          constraints: {
            InclusiveMaximum: 1,
            InclusiveMinimum: 1
          },
          type: {
            name: 'Number'
          }
        },
        maximum: {
          required: false,
          serializedName: 'maximum',
          type: {
            name: 'Number'
          }
        },
        default: {
          required: false,
          serializedName: 'default',
          type: {
            name: 'Number'
          }
        },
        scaleType: {
          required: false,
          serializedName: 'scaleType',
          type: {
            name: 'Enum',
            allowedValues: [ 'Automatic', 'Manual', 'None' ]
          }
        }
      }
    }
  };
};

module.exports = IotHubCapacity;
