/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the IotHubNameAvailabilityInfo class.
 * @constructor
 * The properties indicating whether a given iothub name is available.
 * @member {boolean} [nameAvailable] The value which indicates whether the
 * provided name is available.
 * 
 * @member {string} [reason] The reason for unavailability. Possible values
 * include: 'Invalid', 'AlreadyExists'
 * 
 * @member {string} [message] The message describing the detailed reason.
 * 
 */
function IotHubNameAvailabilityInfo() {
}

/**
 * Defines the metadata of IotHubNameAvailabilityInfo
 *
 * @returns {object} metadata of IotHubNameAvailabilityInfo
 *
 */
IotHubNameAvailabilityInfo.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'IotHubNameAvailabilityInfo',
    type: {
      name: 'Composite',
      className: 'IotHubNameAvailabilityInfo',
      modelProperties: {
        nameAvailable: {
          required: false,
          serializedName: 'nameAvailable',
          type: {
            name: 'Boolean'
          }
        },
        reason: {
          required: false,
          serializedName: 'reason',
          type: {
            name: 'Enum',
            allowedValues: [ 'Invalid', 'AlreadyExists' ]
          }
        },
        message: {
          required: false,
          serializedName: 'message',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = IotHubNameAvailabilityInfo;
