/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the IotHubSkuDescription class.
 * @constructor
 * The properties related to the Sku.
 * @member {string} [resourceType] The type of the resource.
 * 
 * @member {object} [sku]
 * 
 * @member {string} [sku.name] The name of the Sku. Possible values include:
 * 'F1', 'S1', 'S2', 'S3'
 * 
 * @member {string} [sku.tier] The tier. Possible values include: 'Free',
 * 'Standard'
 * 
 * @member {number} [sku.capacity] The number of units being provisioned.
 * Range of values [For F1: 1-1, S1: 1-200, S2: 1-200, S3: 1-10]. To go above
 * this range, call support.
 * 
 * @member {object} [capacity]
 * 
 * @member {number} [capacity.minimum] The minimum number of units.
 * 
 * @member {number} [capacity.maximum] The maximum number of units.
 * 
 * @member {number} [capacity.default] The default number of units.
 * 
 * @member {string} [capacity.scaleType] The type of the scale. Possible
 * values include: 'Automatic', 'Manual', 'None'
 * 
 */
function IotHubSkuDescription() {
}

/**
 * Defines the metadata of IotHubSkuDescription
 *
 * @returns {object} metadata of IotHubSkuDescription
 *
 */
IotHubSkuDescription.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'IotHubSkuDescription',
    type: {
      name: 'Composite',
      className: 'IotHubSkuDescription',
      modelProperties: {
        resourceType: {
          required: false,
          readOnly: true,
          serializedName: 'resourceType',
          type: {
            name: 'String'
          }
        },
        sku: {
          required: false,
          serializedName: 'sku',
          type: {
            name: 'Composite',
            className: 'IotHubSkuInfo'
          }
        },
        capacity: {
          required: false,
          serializedName: 'capacity',
          type: {
            name: 'Composite',
            className: 'IotHubCapacity'
          }
        }
      }
    }
  };
};

module.exports = IotHubSkuDescription;
