/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the IotHubSkuInfo class.
 * @constructor
 * The Sku related information for the hub.
 * @member {string} [name] The name of the Sku. Possible values include: 'F1',
 * 'S1', 'S2', 'S3'
 * 
 * @member {string} [tier] The tier. Possible values include: 'Free',
 * 'Standard'
 * 
 * @member {number} [capacity] The number of units being provisioned. Range of
 * values [For F1: 1-1, S1: 1-200, S2: 1-200, S3: 1-10]. To go above this
 * range, call support.
 * 
 */
function IotHubSkuInfo() {
}

/**
 * Defines the metadata of IotHubSkuInfo
 *
 * @returns {object} metadata of IotHubSkuInfo
 *
 */
IotHubSkuInfo.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'IotHubSkuInfo',
    type: {
      name: 'Composite',
      className: 'IotHubSkuInfo',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        tier: {
          required: false,
          readOnly: true,
          serializedName: 'tier',
          type: {
            name: 'Enum',
            allowedValues: [ 'Free', 'Standard' ]
          }
        },
        capacity: {
          required: false,
          serializedName: 'capacity',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = IotHubSkuInfo;
