/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the JobResponseListResult class.
 * @constructor
 * The list of JobResponse objects with a next link.
 * @member {array} [value] The list of JobResponse.
 * 
 * @member {string} [nextLink] The next link.
 * 
 */
function JobResponseListResult() {
}

util.inherits(JobResponseListResult, Array);

/**
 * Defines the metadata of JobResponseListResult
 *
 * @returns {object} metadata of JobResponseListResult
 *
 */
JobResponseListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'JobResponseListResult',
    type: {
      name: 'Composite',
      className: 'JobResponseListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'JobResponseElementType',
                type: {
                  name: 'Composite',
                  className: 'JobResponse'
                }
            }
          }
        },
        nextLink: {
          required: false,
          readOnly: true,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = JobResponseListResult;
