/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the RegistryStatistics class.
 * @constructor
 * The properties related to the registry statistics.
 * @member {number} [totalDeviceCount] The total device count.
 * 
 * @member {number} [enabledDeviceCount] The enabled device count.
 * 
 * @member {number} [disabledDeviceCount] The disabled device count.
 * 
 */
function RegistryStatistics() {
}

/**
 * Defines the metadata of RegistryStatistics
 *
 * @returns {object} metadata of RegistryStatistics
 *
 */
RegistryStatistics.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'RegistryStatistics',
    type: {
      name: 'Composite',
      className: 'RegistryStatistics',
      modelProperties: {
        totalDeviceCount: {
          required: false,
          serializedName: 'totalDeviceCount',
          type: {
            name: 'Number'
          }
        },
        enabledDeviceCount: {
          required: false,
          serializedName: 'enabledDeviceCount',
          type: {
            name: 'Number'
          }
        },
        disabledDeviceCount: {
          required: false,
          serializedName: 'disabledDeviceCount',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = RegistryStatistics;
