/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the SharedAccessSignatureAuthorizationRuleListResult class.
 * @constructor
 * The list of authorization rules with a next link.
 * @member {array} [value] The list of authorization rules.
 * 
 * @member {string} [nextLink] The next link.
 * 
 */
function SharedAccessSignatureAuthorizationRuleListResult() {
}

util.inherits(SharedAccessSignatureAuthorizationRuleListResult, Array);

/**
 * Defines the metadata of SharedAccessSignatureAuthorizationRuleListResult
 *
 * @returns {object} metadata of SharedAccessSignatureAuthorizationRuleListResult
 *
 */
SharedAccessSignatureAuthorizationRuleListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SharedAccessSignatureAuthorizationRuleListResult',
    type: {
      name: 'Composite',
      className: 'SharedAccessSignatureAuthorizationRuleListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'SharedAccessSignatureAuthorizationRuleElementType',
                type: {
                  name: 'Composite',
                  className: 'SharedAccessSignatureAuthorizationRule'
                }
            }
          }
        },
        nextLink: {
          required: false,
          readOnly: true,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = SharedAccessSignatureAuthorizationRuleListResult;
