/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the StorageEndpointProperties class.
 * @constructor
 * The properties of the Storage Endpoint for file upload.
 * @member {moment.duration} [sasTtlAsIso8601] SAS time to live. Range: 1 Min
 * (PT1M) - 1 Day (P1D).
 * 
 * @member {string} [connectionString] The account key credentials for storage
 * account selected by customer for uploading files.
 * 
 * @member {string} [containerName] The root container name where all files
 * will be uploaded.
 * 
 */
function StorageEndpointProperties() {
}

/**
 * Defines the metadata of StorageEndpointProperties
 *
 * @returns {object} metadata of StorageEndpointProperties
 *
 */
StorageEndpointProperties.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'StorageEndpointProperties',
    type: {
      name: 'Composite',
      className: 'StorageEndpointProperties',
      modelProperties: {
        sasTtlAsIso8601: {
          required: false,
          serializedName: 'sasTtlAsIso8601',
          type: {
            name: 'TimeSpan'
          }
        },
        connectionString: {
          required: false,
          serializedName: 'connectionString',
          type: {
            name: 'String'
          }
        },
        containerName: {
          required: false,
          serializedName: 'containerName',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = StorageEndpointProperties;
