/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ApplicationGatewayBackendHttpSettings class.
 * @constructor
 * Backend address pool settings of application gateway
 *
 * @member {number} [port] Port
 * 
 * @member {string} [protocol] Protocol. Possible values include: 'Http',
 * 'Https'
 * 
 * @member {string} [cookieBasedAffinity] Cookie affinity. Possible values
 * include: 'Enabled', 'Disabled'
 * 
 * @member {number} [requestTimeout] Request timeout
 * 
 * @member {object} [probe] Probe resource of application gateway
 * 
 * @member {string} [probe.id] Resource Id
 * 
 * @member {array} [authenticationCertificates] Array of references to
 * Application Gateway Authentication Certificates
 * 
 * @member {string} [provisioningState] Provisioning state of the backend http
 * settings resource Updating/Deleting/Failed
 * 
 * @member {string} [name] Name of the resource that is unique within a
 * resource group. This name can be used to access the resource
 * 
 * @member {string} [etag] A unique read-only string that changes whenever the
 * resource is updated
 * 
 */
function ApplicationGatewayBackendHttpSettings() {
  ApplicationGatewayBackendHttpSettings['super_'].call(this);
}

util.inherits(ApplicationGatewayBackendHttpSettings, models['SubResource']);

/**
 * Defines the metadata of ApplicationGatewayBackendHttpSettings
 *
 * @returns {object} metadata of ApplicationGatewayBackendHttpSettings
 *
 */
ApplicationGatewayBackendHttpSettings.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ApplicationGatewayBackendHttpSettings',
    type: {
      name: 'Composite',
      className: 'ApplicationGatewayBackendHttpSettings',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        port: {
          required: false,
          serializedName: 'properties.port',
          type: {
            name: 'Number'
          }
        },
        protocol: {
          required: false,
          serializedName: 'properties.protocol',
          type: {
            name: 'String'
          }
        },
        cookieBasedAffinity: {
          required: false,
          serializedName: 'properties.cookieBasedAffinity',
          type: {
            name: 'String'
          }
        },
        requestTimeout: {
          required: false,
          serializedName: 'properties.requestTimeout',
          type: {
            name: 'Number'
          }
        },
        probe: {
          required: false,
          serializedName: 'properties.probe',
          type: {
            name: 'Composite',
            className: 'SubResource'
          }
        },
        authenticationCertificates: {
          required: false,
          serializedName: 'properties.authenticationCertificates',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'SubResourceElementType',
                type: {
                  name: 'Composite',
                  className: 'SubResource'
                }
            }
          }
        },
        provisioningState: {
          required: false,
          serializedName: 'properties.provisioningState',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        etag: {
          required: false,
          serializedName: 'etag',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ApplicationGatewayBackendHttpSettings;
