/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ApplicationGatewaySku class.
 * @constructor
 * SKU of application gateway
 *
 * @member {string} [name] Name of application gateway SKU. Possible values
 * include: 'Standard_Small', 'Standard_Medium', 'Standard_Large'
 * 
 * @member {string} [tier] Tier of application gateway. Possible values
 * include: 'Standard'
 * 
 * @member {number} [capacity] Capacity (instance count) of application gateway
 * 
 */
function ApplicationGatewaySku() {
}

/**
 * Defines the metadata of ApplicationGatewaySku
 *
 * @returns {object} metadata of ApplicationGatewaySku
 *
 */
ApplicationGatewaySku.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ApplicationGatewaySku',
    type: {
      name: 'Composite',
      className: 'ApplicationGatewaySku',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        tier: {
          required: false,
          serializedName: 'tier',
          type: {
            name: 'String'
          }
        },
        capacity: {
          required: false,
          serializedName: 'capacity',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = ApplicationGatewaySku;
