/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the EffectiveNetworkSecurityGroupAssociation class.
 * @constructor
 * Effective NetworkSecurityGroup association
 *
 * @member {object} [subnet] Gets the id of subnet if assigned
 * 
 * @member {string} [subnet.id] Resource Id
 * 
 * @member {object} [networkInterface] Gets the id of network interface if
 * assigned
 * 
 * @member {string} [networkInterface.id] Resource Id
 * 
 */
function EffectiveNetworkSecurityGroupAssociation() {
}

/**
 * Defines the metadata of EffectiveNetworkSecurityGroupAssociation
 *
 * @returns {object} metadata of EffectiveNetworkSecurityGroupAssociation
 *
 */
EffectiveNetworkSecurityGroupAssociation.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'EffectiveNetworkSecurityGroupAssociation',
    type: {
      name: 'Composite',
      className: 'EffectiveNetworkSecurityGroupAssociation',
      modelProperties: {
        subnet: {
          required: false,
          serializedName: 'subnet',
          type: {
            name: 'Composite',
            className: 'SubResource'
          }
        },
        networkInterface: {
          required: false,
          serializedName: 'networkInterface',
          type: {
            name: 'Composite',
            className: 'SubResource'
          }
        }
      }
    }
  };
};

module.exports = EffectiveNetworkSecurityGroupAssociation;
