/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the EffectiveNetworkSecurityGroupListResult class.
 * @constructor
 * Response for list effective network security groups api servive call
 *
 * @member {array} [value] Gets list of effective network security groups
 * 
 * @member {string} [nextLink] Gets the URL to get the next set of results.
 * 
 */
function EffectiveNetworkSecurityGroupListResult() {
}

/**
 * Defines the metadata of EffectiveNetworkSecurityGroupListResult
 *
 * @returns {object} metadata of EffectiveNetworkSecurityGroupListResult
 *
 */
EffectiveNetworkSecurityGroupListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'EffectiveNetworkSecurityGroupListResult',
    type: {
      name: 'Composite',
      className: 'EffectiveNetworkSecurityGroupListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: 'value',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'EffectiveNetworkSecurityGroupElementType',
                type: {
                  name: 'Composite',
                  className: 'EffectiveNetworkSecurityGroup'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = EffectiveNetworkSecurityGroupListResult;
