/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the EffectiveRouteListResult class.
 * @constructor
 * Response for list effective route api servive call
 *
 * @member {array} [value] Gets list of effective routes
 * 
 * @member {string} [nextLink] Gets the URL to get the next set of results.
 * 
 */
function EffectiveRouteListResult() {
}

/**
 * Defines the metadata of EffectiveRouteListResult
 *
 * @returns {object} metadata of EffectiveRouteListResult
 *
 */
EffectiveRouteListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'EffectiveRouteListResult',
    type: {
      name: 'Composite',
      className: 'EffectiveRouteListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: 'value',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'EffectiveRouteElementType',
                type: {
                  name: 'Composite',
                  className: 'EffectiveRoute'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = EffectiveRouteListResult;
