/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the UsagesListResult class.
 * @constructor
 * The List Usages operation response.
 * @member {array} [value] Gets or sets the list Network Resource Usages.
 * 
 * @member {string} [nextLink] URL to get the next set of results.
 * 
 */
function UsagesListResult() {
}

util.inherits(UsagesListResult, Array);

/**
 * Defines the metadata of UsagesListResult
 *
 * @returns {object} metadata of UsagesListResult
 *
 */
UsagesListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'UsagesListResult',
    type: {
      name: 'Composite',
      className: 'UsagesListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'UsageElementType',
                type: {
                  name: 'Composite',
                  className: 'Usage'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = UsagesListResult;
