/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the VirtualNetworkPeeringListResult class.
 * @constructor
 * Response for ListSubnets Api service callRetrieves all subnet that belongs
 * to a virtual network
 * @member {array} [value] Gets the peerings in a virtual network
 * 
 * @member {string} [nextLink] Gets the URL to get the next set of results.
 * 
 */
function VirtualNetworkPeeringListResult() {
}

util.inherits(VirtualNetworkPeeringListResult, Array);

/**
 * Defines the metadata of VirtualNetworkPeeringListResult
 *
 * @returns {object} metadata of VirtualNetworkPeeringListResult
 *
 */
VirtualNetworkPeeringListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VirtualNetworkPeeringListResult',
    type: {
      name: 'Composite',
      className: 'VirtualNetworkPeeringListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'VirtualNetworkPeeringElementType',
                type: {
                  name: 'Composite',
                  className: 'VirtualNetworkPeering'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = VirtualNetworkPeeringListResult;
