/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the AutoHealActions class.
 * @constructor
 * AutoHealActions - Describes the actions which can be
 * taken by the auto-heal module when a rule is triggered.
 * @member {string} actionType ActionType - predefined action to be taken.
 * Possible values include: 'Recycle', 'LogEvent', 'CustomAction'
 * 
 * @member {object} [customAction] CustomAction - custom action to be taken
 * 
 * @member {string} [customAction.exe] Executable to be run
 * 
 * @member {string} [customAction.parameters] Parameters for the executable
 * 
 * @member {string} [minProcessExecutionTime] MinProcessExecutionTime -
 * minimum time the process must execute
 * before taking the action
 * 
 */
function AutoHealActions() {
}

/**
 * Defines the metadata of AutoHealActions
 *
 * @returns {object} metadata of AutoHealActions
 *
 */
AutoHealActions.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'AutoHealActions',
    type: {
      name: 'Composite',
      className: 'AutoHealActions',
      modelProperties: {
        actionType: {
          required: true,
          serializedName: 'actionType',
          type: {
            name: 'Enum',
            allowedValues: [ 'Recycle', 'LogEvent', 'CustomAction' ]
          }
        },
        customAction: {
          required: false,
          serializedName: 'customAction',
          type: {
            name: 'Composite',
            className: 'AutoHealCustomAction'
          }
        },
        minProcessExecutionTime: {
          required: false,
          serializedName: 'minProcessExecutionTime',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = AutoHealActions;
