/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the AutoHealRules class.
 * @constructor
 * AutoHealRules - describes the rules which can be defined for auto-heal
 * @member {object} [triggers] Triggers - Conditions that describe when to
 * execute the auto-heal actions
 * 
 * @member {object} [triggers.requests] Requests - Defines a rule based on
 * total requests
 * 
 * @member {number} [triggers.requests.count] Count
 * 
 * @member {string} [triggers.requests.timeInterval] TimeInterval
 * 
 * @member {number} [triggers.privateBytesInKB] PrivateBytesInKB - Defines a
 * rule based on private bytes
 * 
 * @member {array} [triggers.statusCodes] StatusCodes - Defines a rule based
 * on status codes
 * 
 * @member {object} [triggers.slowRequests] SlowRequests - Defines a rule
 * based on request execution time
 * 
 * @member {string} [triggers.slowRequests.timeTaken] TimeTaken
 * 
 * @member {number} [triggers.slowRequests.count] Count
 * 
 * @member {string} [triggers.slowRequests.timeInterval] TimeInterval
 * 
 * @member {object} [actions] Actions - Actions to be executed when a rule is
 * triggered
 * 
 * @member {string} [actions.actionType] ActionType - predefined action to be
 * taken. Possible values include: 'Recycle', 'LogEvent', 'CustomAction'
 * 
 * @member {object} [actions.customAction] CustomAction - custom action to be
 * taken
 * 
 * @member {string} [actions.customAction.exe] Executable to be run
 * 
 * @member {string} [actions.customAction.parameters] Parameters for the
 * executable
 * 
 * @member {string} [actions.minProcessExecutionTime] MinProcessExecutionTime
 * - minimum time the process must execute
 * before taking the action
 * 
 */
function AutoHealRules() {
}

/**
 * Defines the metadata of AutoHealRules
 *
 * @returns {object} metadata of AutoHealRules
 *
 */
AutoHealRules.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'AutoHealRules',
    type: {
      name: 'Composite',
      className: 'AutoHealRules',
      modelProperties: {
        triggers: {
          required: false,
          serializedName: 'triggers',
          type: {
            name: 'Composite',
            className: 'AutoHealTriggers'
          }
        },
        actions: {
          required: false,
          serializedName: 'actions',
          type: {
            name: 'Composite',
            className: 'AutoHealActions'
          }
        }
      }
    }
  };
};

module.exports = AutoHealRules;
