/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the AutoHealTriggers class.
 * @constructor
 * AutoHealTriggers - describes the triggers for auto-heal.
 * @member {object} [requests] Requests - Defines a rule based on total
 * requests
 * 
 * @member {number} [requests.count] Count
 * 
 * @member {string} [requests.timeInterval] TimeInterval
 * 
 * @member {number} [privateBytesInKB] PrivateBytesInKB - Defines a rule based
 * on private bytes
 * 
 * @member {array} [statusCodes] StatusCodes - Defines a rule based on status
 * codes
 * 
 * @member {object} [slowRequests] SlowRequests - Defines a rule based on
 * request execution time
 * 
 * @member {string} [slowRequests.timeTaken] TimeTaken
 * 
 * @member {number} [slowRequests.count] Count
 * 
 * @member {string} [slowRequests.timeInterval] TimeInterval
 * 
 */
function AutoHealTriggers() {
}

/**
 * Defines the metadata of AutoHealTriggers
 *
 * @returns {object} metadata of AutoHealTriggers
 *
 */
AutoHealTriggers.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'AutoHealTriggers',
    type: {
      name: 'Composite',
      className: 'AutoHealTriggers',
      modelProperties: {
        requests: {
          required: false,
          serializedName: 'requests',
          type: {
            name: 'Composite',
            className: 'RequestsBasedTrigger'
          }
        },
        privateBytesInKB: {
          required: false,
          serializedName: 'privateBytesInKB',
          type: {
            name: 'Number'
          }
        },
        statusCodes: {
          required: false,
          serializedName: 'statusCodes',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StatusCodesBasedTriggerElementType',
                type: {
                  name: 'Composite',
                  className: 'StatusCodesBasedTrigger'
                }
            }
          }
        },
        slowRequests: {
          required: false,
          serializedName: 'slowRequests',
          type: {
            name: 'Composite',
            className: 'SlowRequestsBasedTrigger'
          }
        }
      }
    }
  };
};

module.exports = AutoHealTriggers;
