/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the AzureTableStorageApplicationLogsConfig class.
 * @constructor
 * Application logs to azure table storage configuration
 * @member {string} [level] Log level. Possible values include: 'Off',
 * 'Verbose', 'Information', 'Warning', 'Error'
 * 
 * @member {string} [sasUrl] SAS url to an azure table with add/query/delete
 * permissions
 * 
 */
function AzureTableStorageApplicationLogsConfig() {
}

/**
 * Defines the metadata of AzureTableStorageApplicationLogsConfig
 *
 * @returns {object} metadata of AzureTableStorageApplicationLogsConfig
 *
 */
AzureTableStorageApplicationLogsConfig.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'AzureTableStorageApplicationLogsConfig',
    type: {
      name: 'Composite',
      className: 'AzureTableStorageApplicationLogsConfig',
      modelProperties: {
        level: {
          required: false,
          serializedName: 'level',
          type: {
            name: 'Enum',
            allowedValues: [ 'Off', 'Verbose', 'Information', 'Warning', 'Error' ]
          }
        },
        sasUrl: {
          required: false,
          serializedName: 'sasUrl',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = AzureTableStorageApplicationLogsConfig;
