/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ConnStringInfo class.
 * @constructor
 * Represents database connection string information
 * @member {string} [name] Name of connection string
 * 
 * @member {string} [connectionString] Connection string value
 * 
 * @member {string} type Type of database. Possible values include: 'MySql',
 * 'SQLServer', 'SQLAzure', 'Custom'
 * 
 */
function ConnStringInfo() {
}

/**
 * Defines the metadata of ConnStringInfo
 *
 * @returns {object} metadata of ConnStringInfo
 *
 */
ConnStringInfo.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ConnStringInfo',
    type: {
      name: 'Composite',
      className: 'ConnStringInfo',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        connectionString: {
          required: false,
          serializedName: 'connectionString',
          type: {
            name: 'String'
          }
        },
        type: {
          required: true,
          serializedName: 'type',
          type: {
            name: 'Enum',
            allowedValues: [ 'MySql', 'SQLServer', 'SQLAzure', 'Custom' ]
          }
        }
      }
    }
  };
};

module.exports = ConnStringInfo;
