/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ConnectionStringDictionary class.
 * @constructor
 * String dictionary resource
 * @member {object} [properties] Connection strings
 * 
 */
function ConnectionStringDictionary() {
  ConnectionStringDictionary['super_'].call(this);
}

util.inherits(ConnectionStringDictionary, models['Resource']);

/**
 * Defines the metadata of ConnectionStringDictionary
 *
 * @returns {object} metadata of ConnectionStringDictionary
 *
 */
ConnectionStringDictionary.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ConnectionStringDictionary',
    type: {
      name: 'Composite',
      className: 'ConnectionStringDictionary',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        location: {
          required: true,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        properties: {
          required: false,
          serializedName: 'properties',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'ConnStringValueTypePairElementType',
                type: {
                  name: 'Composite',
                  className: 'ConnStringValueTypePair'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = ConnectionStringDictionary;
