/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the CsmSiteRecoveryEntity class.
 * @constructor
 * Class containting details about site recovery operation.
 * @member {date} [snapshotTime] Point in time in which the site recover
 * should be attempted.
 * 
 * @member {string} [siteName] [Optional] Destination web app name into which
 * web app should be recovered. This is case when new web app should be
 * created instead.
 * 
 * @member {string} [slotName] [Optional] Destination web app slot name into
 * which web app should be recovered
 * 
 */
function CsmSiteRecoveryEntity() {
}

/**
 * Defines the metadata of CsmSiteRecoveryEntity
 *
 * @returns {object} metadata of CsmSiteRecoveryEntity
 *
 */
CsmSiteRecoveryEntity.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'CsmSiteRecoveryEntity',
    type: {
      name: 'Composite',
      className: 'CsmSiteRecoveryEntity',
      modelProperties: {
        snapshotTime: {
          required: false,
          serializedName: 'snapshotTime',
          type: {
            name: 'DateTime'
          }
        },
        siteName: {
          required: false,
          serializedName: 'siteName',
          type: {
            name: 'String'
          }
        },
        slotName: {
          required: false,
          serializedName: 'slotName',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = CsmSiteRecoveryEntity;
