/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the Deployment class.
 * @constructor
 * Represents user crendentials used for publishing activity
 * @member {string} [deploymentId] Id
 * 
 * @member {number} [status] Status
 * 
 * @member {string} [message] Message
 * 
 * @member {string} [author] Author
 * 
 * @member {string} [deployer] Deployer
 * 
 * @member {string} [authorEmail] AuthorEmail
 * 
 * @member {date} [startTime] StartTime
 * 
 * @member {date} [endTime] EndTime
 * 
 * @member {boolean} [active] Active
 * 
 * @member {string} [details] Detail
 * 
 */
function Deployment() {
  Deployment['super_'].call(this);
}

util.inherits(Deployment, models['Resource']);

/**
 * Defines the metadata of Deployment
 *
 * @returns {object} metadata of Deployment
 *
 */
Deployment.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Deployment',
    type: {
      name: 'Composite',
      className: 'Deployment',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        location: {
          required: true,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        deploymentId: {
          required: false,
          serializedName: 'properties.id',
          type: {
            name: 'String'
          }
        },
        status: {
          required: false,
          serializedName: 'properties.status',
          type: {
            name: 'Number'
          }
        },
        message: {
          required: false,
          serializedName: 'properties.message',
          type: {
            name: 'String'
          }
        },
        author: {
          required: false,
          serializedName: 'properties.author',
          type: {
            name: 'String'
          }
        },
        deployer: {
          required: false,
          serializedName: 'properties.deployer',
          type: {
            name: 'String'
          }
        },
        authorEmail: {
          required: false,
          serializedName: 'properties.author_email',
          type: {
            name: 'String'
          }
        },
        startTime: {
          required: false,
          serializedName: 'properties.start_time',
          type: {
            name: 'DateTime'
          }
        },
        endTime: {
          required: false,
          serializedName: 'properties.end_time',
          type: {
            name: 'DateTime'
          }
        },
        active: {
          required: false,
          serializedName: 'properties.active',
          type: {
            name: 'Boolean'
          }
        },
        details: {
          required: false,
          serializedName: 'properties.details',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = Deployment;
