/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the DomainAvailablilityCheckResult class.
 * @constructor
 * Domain availablility check result
 * @member {string} [name] Name of the domain
 * 
 * @member {boolean} [available] If true then domain can be purchased using
 * CreateDomain Api
 * 
 * @member {string} [domainType] Domain type. Possible values include:
 * 'Regular', 'SoftDeleted'
 * 
 */
function DomainAvailablilityCheckResult() {
}

/**
 * Defines the metadata of DomainAvailablilityCheckResult
 *
 * @returns {object} metadata of DomainAvailablilityCheckResult
 *
 */
DomainAvailablilityCheckResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'DomainAvailablilityCheckResult',
    type: {
      name: 'Composite',
      className: 'DomainAvailablilityCheckResult',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        available: {
          required: false,
          serializedName: 'available',
          type: {
            name: 'Boolean'
          }
        },
        domainType: {
          required: false,
          serializedName: 'domainType',
          type: {
            name: 'Enum',
            allowedValues: [ 'Regular', 'SoftDeleted' ]
          }
        }
      }
    }
  };
};

module.exports = DomainAvailablilityCheckResult;
