/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the DomainControlCenterSsoRequest class.
 * @constructor
 * Single sign on request information for domain management
 * @member {string} [url] Url where the single sign on request is to be made
 * 
 * @member {string} [postParameterKey] Post parameter key
 * 
 * @member {string} [postParameterValue] Post parameter value. Client should
 * use 'application/x-www-form-urlencoded' encoding for this value.
 * 
 */
function DomainControlCenterSsoRequest() {
}

/**
 * Defines the metadata of DomainControlCenterSsoRequest
 *
 * @returns {object} metadata of DomainControlCenterSsoRequest
 *
 */
DomainControlCenterSsoRequest.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'DomainControlCenterSsoRequest',
    type: {
      name: 'Composite',
      className: 'DomainControlCenterSsoRequest',
      modelProperties: {
        url: {
          required: false,
          serializedName: 'url',
          type: {
            name: 'String'
          }
        },
        postParameterKey: {
          required: false,
          serializedName: 'postParameterKey',
          type: {
            name: 'String'
          }
        },
        postParameterValue: {
          required: false,
          serializedName: 'postParameterValue',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = DomainControlCenterSsoRequest;
