/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the GeoRegion class.
 * @constructor
 * Geographical region
 * @member {string} [geoRegionName] Region name
 * 
 * @member {string} [description] Region description
 * 
 * @member {string} [displayName] Display name for region
 * 
 */
function GeoRegion() {
  GeoRegion['super_'].call(this);
}

util.inherits(GeoRegion, models['Resource']);

/**
 * Defines the metadata of GeoRegion
 *
 * @returns {object} metadata of GeoRegion
 *
 */
GeoRegion.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'GeoRegion',
    type: {
      name: 'Composite',
      className: 'GeoRegion',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        location: {
          required: true,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        geoRegionName: {
          required: false,
          serializedName: 'properties.name',
          type: {
            name: 'String'
          }
        },
        description: {
          required: false,
          serializedName: 'properties.description',
          type: {
            name: 'String'
          }
        },
        displayName: {
          required: false,
          serializedName: 'properties.displayName',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = GeoRegion;
