/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the HostName class.
 * @constructor
 * Details of a hostname derived from a domain
 * @member {string} [name] Name of the hostname
 * 
 * @member {array} [siteNames] List of sites the hostname is assigned to. This
 * list will have more than one site only if the hostname is pointing to a
 * Traffic Manager
 * 
 * @member {string} [azureResourceName] Name of the Azure resource the
 * hostname is assigned to. If it is assigned to a traffic manager then it
 * will be the traffic manager name otherwise it will be the website name
 * 
 * @member {string} [azureResourceType] Type of the Azure resource the
 * hostname is assigned to. Possible values include: 'Website',
 * 'TrafficManager'
 * 
 * @member {string} [customHostNameDnsRecordType] Type of the Dns record.
 * Possible values include: 'CName', 'A'
 * 
 * @member {string} [hostNameType] Type of the hostname. Possible values
 * include: 'Verified', 'Managed'
 * 
 */
function HostName() {
}

/**
 * Defines the metadata of HostName
 *
 * @returns {object} metadata of HostName
 *
 */
HostName.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'HostName',
    type: {
      name: 'Composite',
      className: 'HostName',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        siteNames: {
          required: false,
          serializedName: 'siteNames',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        azureResourceName: {
          required: false,
          serializedName: 'azureResourceName',
          type: {
            name: 'String'
          }
        },
        azureResourceType: {
          required: false,
          serializedName: 'azureResourceType',
          type: {
            name: 'Enum',
            allowedValues: [ 'Website', 'TrafficManager' ]
          }
        },
        customHostNameDnsRecordType: {
          required: false,
          serializedName: 'customHostNameDnsRecordType',
          type: {
            name: 'Enum',
            allowedValues: [ 'CName', 'A' ]
          }
        },
        hostNameType: {
          required: false,
          serializedName: 'hostNameType',
          type: {
            name: 'Enum',
            allowedValues: [ 'Verified', 'Managed' ]
          }
        }
      }
    }
  };
};

module.exports = HostName;
