/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.CertificateCollection = require('./certificateCollection');
exports.Resource = require('./resource');
exports.Certificate = require('./certificate');
exports.HostingEnvironmentProfile = require('./hostingEnvironmentProfile');
exports.ArmPlan = require('./armPlan');
exports.SkuDescription = require('./skuDescription');
exports.Csr = require('./csr');
exports.ClassicMobileServiceCollection = require('./classicMobileServiceCollection');
exports.ClassicMobileService = require('./classicMobileService');
exports.DomainCollection = require('./domainCollection');
exports.Domain = require('./domain');
exports.Contact = require('./contact');
exports.Address = require('./address');
exports.HostName = require('./hostName');
exports.DomainPurchaseConsent = require('./domainPurchaseConsent');
exports.User = require('./user');
exports.GeoRegionCollection = require('./geoRegionCollection');
exports.GeoRegion = require('./geoRegion');
exports.ServerFarmCollection = require('./serverFarmCollection');
exports.ServerFarmWithRichSku = require('./serverFarmWithRichSku');
exports.Site = require('./site');
exports.HostNameSslState = require('./hostNameSslState');
exports.SiteConfig = require('./siteConfig');
exports.NameValuePair = require('./nameValuePair');
exports.ConnStringInfo = require('./connStringInfo');
exports.HandlerMapping = require('./handlerMapping');
exports.VirtualApplication = require('./virtualApplication');
exports.VirtualDirectory = require('./virtualDirectory');
exports.Experiments = require('./experiments');
exports.RampUpRule = require('./rampUpRule');
exports.SiteLimits = require('./siteLimits');
exports.AutoHealRules = require('./autoHealRules');
exports.AutoHealTriggers = require('./autoHealTriggers');
exports.RequestsBasedTrigger = require('./requestsBasedTrigger');
exports.StatusCodesBasedTrigger = require('./statusCodesBasedTrigger');
exports.SlowRequestsBasedTrigger = require('./slowRequestsBasedTrigger');
exports.AutoHealActions = require('./autoHealActions');
exports.AutoHealCustomAction = require('./autoHealCustomAction');
exports.CorsSettings = require('./corsSettings');
exports.ApiDefinitionInfo = require('./apiDefinitionInfo');
exports.CloningInfo = require('./cloningInfo');
exports.SiteProperties = require('./siteProperties');
exports.RoutingRule = require('./routingRule');
exports.SiteAuthSettings = require('./siteAuthSettings');
exports.HostingEnvironmentCollection = require('./hostingEnvironmentCollection');
exports.HostingEnvironment = require('./hostingEnvironment');
exports.VirtualNetworkProfile = require('./virtualNetworkProfile');
exports.WorkerPool = require('./workerPool');
exports.VirtualIPMapping = require('./virtualIPMapping');
exports.StampCapacity = require('./stampCapacity');
exports.NetworkAccessControlEntry = require('./networkAccessControlEntry');
exports.ManagedHostingEnvironmentCollection = require('./managedHostingEnvironmentCollection');
exports.ManagedHostingEnvironment = require('./managedHostingEnvironment');
exports.ResourceNameAvailabilityRequest = require('./resourceNameAvailabilityRequest');
exports.ResourceNameAvailability = require('./resourceNameAvailability');
exports.DomainControlCenterSsoRequest = require('./domainControlCenterSsoRequest');
exports.DomainRegistrationInput = require('./domainRegistrationInput');
exports.NameIdentifier = require('./nameIdentifier');
exports.DomainAvailablilityCheckResult = require('./domainAvailablilityCheckResult');
exports.DomainRecommendationSearchParameters = require('./domainRecommendationSearchParameters');
exports.NameIdentifierCollection = require('./nameIdentifierCollection');
exports.CsmMoveResourceEnvelope = require('./csmMoveResourceEnvelope');
exports.HostingEnvironmentDiagnostics = require('./hostingEnvironmentDiagnostics');
exports.StampCapacityCollection = require('./stampCapacityCollection');
exports.AddressResponse = require('./addressResponse');
exports.ResourceMetricCollection = require('./resourceMetricCollection');
exports.ResourceMetric = require('./resourceMetric');
exports.ResourceMetricName = require('./resourceMetricName');
exports.ResourceMetricValue = require('./resourceMetricValue');
exports.KeyValuePairStringString = require('./keyValuePairStringString');
exports.MetricDefinition = require('./metricDefinition');
exports.MetricAvailabilily = require('./metricAvailabilily');
exports.CsmUsageQuotaCollection = require('./csmUsageQuotaCollection');
exports.CsmUsageQuota = require('./csmUsageQuota');
exports.LocalizableString = require('./localizableString');
exports.MetricDefinitionCollection = require('./metricDefinitionCollection');
exports.UsageCollection = require('./usageCollection');
exports.Usage = require('./usage');
exports.WorkerPoolCollection = require('./workerPoolCollection');
exports.SkuInfoCollection = require('./skuInfoCollection');
exports.SkuInfo = require('./skuInfo');
exports.SkuCapacity = require('./skuCapacity');
exports.SourceControlCollection = require('./sourceControlCollection');
exports.SourceControl = require('./sourceControl');
exports.VnetInfo = require('./vnetInfo');
exports.VnetRoute = require('./vnetRoute');
exports.VnetGateway = require('./vnetGateway');
exports.NetworkFeatures = require('./networkFeatures');
exports.RelayServiceConnectionEntity = require('./relayServiceConnectionEntity');
exports.CsmSlotEntity = require('./csmSlotEntity');
exports.SlotDifferenceCollection = require('./slotDifferenceCollection');
exports.SlotDifference = require('./slotDifference');
exports.SlotConfigNamesResource = require('./slotConfigNamesResource');
exports.SlotConfigNames = require('./slotConfigNames');
exports.CsmSiteRecoveryEntity = require('./csmSiteRecoveryEntity');
exports.DeletedSiteCollection = require('./deletedSiteCollection');
exports.DeletedSite = require('./deletedSite');
exports.DeploymentCollection = require('./deploymentCollection');
exports.Deployment = require('./deployment');
exports.SiteInstanceCollection = require('./siteInstanceCollection');
exports.SiteInstance = require('./siteInstance');
exports.HostNameBindingCollection = require('./hostNameBindingCollection');
exports.HostNameBinding = require('./hostNameBinding');
exports.SiteSourceControl = require('./siteSourceControl');
exports.StringDictionary = require('./stringDictionary');
exports.ConnectionStringDictionary = require('./connectionStringDictionary');
exports.ConnStringValueTypePair = require('./connStringValueTypePair');
exports.SiteLogsConfig = require('./siteLogsConfig');
exports.ApplicationLogsConfig = require('./applicationLogsConfig');
exports.FileSystemApplicationLogsConfig = require('./fileSystemApplicationLogsConfig');
exports.AzureTableStorageApplicationLogsConfig = require('./azureTableStorageApplicationLogsConfig');
exports.AzureBlobStorageApplicationLogsConfig = require('./azureBlobStorageApplicationLogsConfig');
exports.HttpLogsConfig = require('./httpLogsConfig');
exports.FileSystemHttpLogsConfig = require('./fileSystemHttpLogsConfig');
exports.AzureBlobStorageHttpLogsConfig = require('./azureBlobStorageHttpLogsConfig');
exports.EnabledConfig = require('./enabledConfig');
exports.PremierAddOnRequest = require('./premierAddOnRequest');
exports.BackupRequest = require('./backupRequest');
exports.BackupSchedule = require('./backupSchedule');
exports.DatabaseBackupSetting = require('./databaseBackupSetting');
exports.BackupItem = require('./backupItem');
exports.RestoreRequest = require('./restoreRequest');
exports.BackupItemCollection = require('./backupItemCollection');
exports.RestoreResponse = require('./restoreResponse');
exports.CsmPublishingProfileOptions = require('./csmPublishingProfileOptions');
exports.TopLevelDomainCollection = require('./topLevelDomainCollection');
exports.TopLevelDomain = require('./topLevelDomain');
exports.TopLevelDomainAgreementOption = require('./topLevelDomainAgreementOption');
exports.TldLegalAgreementCollection = require('./tldLegalAgreementCollection');
exports.TldLegalAgreement = require('./tldLegalAgreement');
exports.SiteCollection = require('./siteCollection');
