/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the PremierAddOnRequest class.
 * @constructor
 * @member {string} [location] Geo region resource belongs to e.g.
 * SouthCentralUS, SouthEastAsia
 * 
 * @member {object} [tags] Tags associated with resource
 * 
 * @member {object} [plan] Azure resource manager plan
 * 
 * @member {string} [plan.name] The name
 * 
 * @member {string} [plan.publisher] The publisher
 * 
 * @member {string} [plan.product] The product
 * 
 * @member {string} [plan.promotionCode] The promotion code
 * 
 * @member {string} [plan.version] Version of product
 * 
 * @member {object} [properties] Resource specific properties
 * 
 * @member {object} [sku] Sku description of the resource
 * 
 * @member {string} [sku.name] Name of the resource sku
 * 
 * @member {string} [sku.tier] Service Tier of the resource sku
 * 
 * @member {string} [sku.size] Size specifier of the resource sku
 * 
 * @member {string} [sku.family] Family code of the resource sku
 * 
 * @member {number} [sku.capacity] Current number of instances assigned to the
 * resource
 * 
 */
function PremierAddOnRequest() {
}

/**
 * Defines the metadata of PremierAddOnRequest
 *
 * @returns {object} metadata of PremierAddOnRequest
 *
 */
PremierAddOnRequest.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'PremierAddOnRequest',
    type: {
      name: 'Composite',
      className: 'PremierAddOnRequest',
      modelProperties: {
        location: {
          required: false,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        plan: {
          required: false,
          serializedName: 'plan',
          type: {
            name: 'Composite',
            className: 'ArmPlan'
          }
        },
        properties: {
          required: false,
          serializedName: 'properties',
          type: {
            name: 'Object'
          }
        },
        sku: {
          required: false,
          serializedName: 'sku',
          type: {
            name: 'Composite',
            className: 'SkuDescription'
          }
        }
      }
    }
  };
};

module.exports = PremierAddOnRequest;
