/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ResourceNameAvailability class.
 * @constructor
 * Describes if a resource name is available
 * @member {boolean} [nameAvailable] True indicates name is valid and
 * available.  False indicates the name is invalid, unavailable, or both.
 * 
 * @member {string} [reason] Required if nameAvailable is false. 'Invalid'
 * indicates the name provided does not match Azure WebApp service's naming
 * requirements. 'AlreadyExists' indicates that the name is already in use
 * and is therefore unavailable.
 * 
 * @member {string} [message]
 * 
 */
function ResourceNameAvailability() {
}

/**
 * Defines the metadata of ResourceNameAvailability
 *
 * @returns {object} metadata of ResourceNameAvailability
 *
 */
ResourceNameAvailability.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ResourceNameAvailability',
    type: {
      name: 'Composite',
      className: 'ResourceNameAvailability',
      modelProperties: {
        nameAvailable: {
          required: false,
          serializedName: 'nameAvailable',
          type: {
            name: 'Boolean'
          }
        },
        reason: {
          required: false,
          serializedName: 'reason',
          type: {
            name: 'String'
          }
        },
        message: {
          required: false,
          serializedName: 'message',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ResourceNameAvailability;
