/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the RestoreResponse class.
 * @constructor
 * Response for a restore site request
 * @member {string} [operationId] When server starts the restore process, it
 * will return an OperationId identifying that particular restore operation
 * 
 */
function RestoreResponse() {
  RestoreResponse['super_'].call(this);
}

util.inherits(RestoreResponse, models['Resource']);

/**
 * Defines the metadata of RestoreResponse
 *
 * @returns {object} metadata of RestoreResponse
 *
 */
RestoreResponse.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'RestoreResponse',
    type: {
      name: 'Composite',
      className: 'RestoreResponse',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        location: {
          required: true,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        operationId: {
          required: false,
          serializedName: 'properties.operationId',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = RestoreResponse;
