/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the SiteInstance class.
 * @constructor
 * Instance of a web app
 * @member {string} [siteInstanceName] Name of instance
 * 
 */
function SiteInstance() {
  SiteInstance['super_'].call(this);
}

util.inherits(SiteInstance, models['Resource']);

/**
 * Defines the metadata of SiteInstance
 *
 * @returns {object} metadata of SiteInstance
 *
 */
SiteInstance.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SiteInstance',
    type: {
      name: 'Composite',
      className: 'SiteInstance',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        location: {
          required: true,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        siteInstanceName: {
          required: false,
          serializedName: 'properties.name',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = SiteInstance;
