/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the SiteLimits class.
 * @constructor
 * Represents metric limits set on a web app.
 * @member {number} [maxPercentageCpu] Maximum allowed CPU usage percentage
 * 
 * @member {number} [maxMemoryInMb] Maximum allowed memory usage in MB
 * 
 * @member {number} [maxDiskSizeInMb] Maximum allowed disk size usage in MB
 * 
 */
function SiteLimits() {
}

/**
 * Defines the metadata of SiteLimits
 *
 * @returns {object} metadata of SiteLimits
 *
 */
SiteLimits.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SiteLimits',
    type: {
      name: 'Composite',
      className: 'SiteLimits',
      modelProperties: {
        maxPercentageCpu: {
          required: false,
          serializedName: 'maxPercentageCpu',
          type: {
            name: 'Number'
          }
        },
        maxMemoryInMb: {
          required: false,
          serializedName: 'maxMemoryInMb',
          type: {
            name: 'Number'
          }
        },
        maxDiskSizeInMb: {
          required: false,
          serializedName: 'maxDiskSizeInMb',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = SiteLimits;
