/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the SkuCapacity class.
 * @constructor
 * Description of the App Service Plan scale options
 * @member {number} [minimum] Minimum number of Workers for this App Service
 * Plan SKU
 * 
 * @member {number} [maximum] Maximum number of Workers for this App Service
 * Plan SKU
 * 
 * @member {number} [default] Default number of Workers for this App Service
 * Plan SKU
 * 
 * @member {string} [scaleType] Available scale configurations for an App
 * Service Plan
 * 
 */
function SkuCapacity() {
}

/**
 * Defines the metadata of SkuCapacity
 *
 * @returns {object} metadata of SkuCapacity
 *
 */
SkuCapacity.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SkuCapacity',
    type: {
      name: 'Composite',
      className: 'SkuCapacity',
      modelProperties: {
        minimum: {
          required: false,
          serializedName: 'minimum',
          type: {
            name: 'Number'
          }
        },
        maximum: {
          required: false,
          serializedName: 'maximum',
          type: {
            name: 'Number'
          }
        },
        default: {
          required: false,
          serializedName: 'default',
          type: {
            name: 'Number'
          }
        },
        scaleType: {
          required: false,
          serializedName: 'scaleType',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = SkuCapacity;
