/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the SkuDescription class.
 * @constructor
 * Describes a sku for a scalable resource
 * @member {string} [name] Name of the resource sku
 * 
 * @member {string} [tier] Service Tier of the resource sku
 * 
 * @member {string} [size] Size specifier of the resource sku
 * 
 * @member {string} [family] Family code of the resource sku
 * 
 * @member {number} [capacity] Current number of instances assigned to the
 * resource
 * 
 */
function SkuDescription() {
}

/**
 * Defines the metadata of SkuDescription
 *
 * @returns {object} metadata of SkuDescription
 *
 */
SkuDescription.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SkuDescription',
    type: {
      name: 'Composite',
      className: 'SkuDescription',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        tier: {
          required: false,
          serializedName: 'tier',
          type: {
            name: 'String'
          }
        },
        size: {
          required: false,
          serializedName: 'size',
          type: {
            name: 'String'
          }
        },
        family: {
          required: false,
          serializedName: 'family',
          type: {
            name: 'String'
          }
        },
        capacity: {
          required: false,
          serializedName: 'capacity',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = SkuDescription;
