/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the SkuInfo class.
 * @constructor
 * Sku discovery information
 * @member {string} [resourceType] Resource type that this sku applies to
 * 
 * @member {object} [sku] Name and tier of the sku
 * 
 * @member {string} [sku.name] Name of the resource sku
 * 
 * @member {string} [sku.tier] Service Tier of the resource sku
 * 
 * @member {string} [sku.size] Size specifier of the resource sku
 * 
 * @member {string} [sku.family] Family code of the resource sku
 * 
 * @member {number} [sku.capacity] Current number of instances assigned to the
 * resource
 * 
 * @member {object} [capacity] Min, max, and default scale values of the sku
 * 
 * @member {number} [capacity.minimum] Minimum number of Workers for this App
 * Service Plan SKU
 * 
 * @member {number} [capacity.maximum] Maximum number of Workers for this App
 * Service Plan SKU
 * 
 * @member {number} [capacity.default] Default number of Workers for this App
 * Service Plan SKU
 * 
 * @member {string} [capacity.scaleType] Available scale configurations for an
 * App Service Plan
 * 
 */
function SkuInfo() {
}

/**
 * Defines the metadata of SkuInfo
 *
 * @returns {object} metadata of SkuInfo
 *
 */
SkuInfo.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SkuInfo',
    type: {
      name: 'Composite',
      className: 'SkuInfo',
      modelProperties: {
        resourceType: {
          required: false,
          serializedName: 'resourceType',
          type: {
            name: 'String'
          }
        },
        sku: {
          required: false,
          serializedName: 'sku',
          type: {
            name: 'Composite',
            className: 'SkuDescription'
          }
        },
        capacity: {
          required: false,
          serializedName: 'capacity',
          type: {
            name: 'Composite',
            className: 'SkuCapacity'
          }
        }
      }
    }
  };
};

module.exports = SkuInfo;
