/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the SlotConfigNamesResource class.
 * @constructor
 * Slot Config names azure resource
 * @member {array} [connectionStringNames] List of connection string names
 * 
 * @member {array} [appSettingNames] List of application settings names
 * 
 */
function SlotConfigNamesResource() {
  SlotConfigNamesResource['super_'].call(this);
}

util.inherits(SlotConfigNamesResource, models['Resource']);

/**
 * Defines the metadata of SlotConfigNamesResource
 *
 * @returns {object} metadata of SlotConfigNamesResource
 *
 */
SlotConfigNamesResource.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SlotConfigNamesResource',
    type: {
      name: 'Composite',
      className: 'SlotConfigNamesResource',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        location: {
          required: true,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        connectionStringNames: {
          required: false,
          serializedName: 'properties.connectionStringNames',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        appSettingNames: {
          required: false,
          serializedName: 'properties.appSettingNames',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = SlotConfigNamesResource;
