/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the SourceControl class.
 * @constructor
 * Describes the Source Control OAuth Token
 * @member {string} [sourceControlName] Name or Source Control Type
 * 
 * @member {string} [token] OAuth Access Token
 * 
 * @member {string} [tokenSecret] OAuth Access Token Secret
 * 
 * @member {string} [refreshToken] OAuth Refresh Token
 * 
 * @member {date} [expirationTime] OAuth Token Expiration
 * 
 */
function SourceControl() {
  SourceControl['super_'].call(this);
}

util.inherits(SourceControl, models['Resource']);

/**
 * Defines the metadata of SourceControl
 *
 * @returns {object} metadata of SourceControl
 *
 */
SourceControl.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SourceControl',
    type: {
      name: 'Composite',
      className: 'SourceControl',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        location: {
          required: true,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        sourceControlName: {
          required: false,
          serializedName: 'properties.name',
          type: {
            name: 'String'
          }
        },
        token: {
          required: false,
          serializedName: 'properties.token',
          type: {
            name: 'String'
          }
        },
        tokenSecret: {
          required: false,
          serializedName: 'properties.tokenSecret',
          type: {
            name: 'String'
          }
        },
        refreshToken: {
          required: false,
          serializedName: 'properties.refreshToken',
          type: {
            name: 'String'
          }
        },
        expirationTime: {
          required: false,
          serializedName: 'properties.expirationTime',
          type: {
            name: 'DateTime'
          }
        }
      }
    }
  };
};

module.exports = SourceControl;
