/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the TldLegalAgreement class.
 * @constructor
 * Represents a legal agreement for top level domain
 * @member {string} [agreementKey] Unique identifier for the agreement
 * 
 * @member {string} [title] Agreement title
 * 
 * @member {string} [content] Agreement details
 * 
 * @member {string} [url] Url where a copy of the agreement details is hosted
 * 
 */
function TldLegalAgreement() {
}

/**
 * Defines the metadata of TldLegalAgreement
 *
 * @returns {object} metadata of TldLegalAgreement
 *
 */
TldLegalAgreement.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'TldLegalAgreement',
    type: {
      name: 'Composite',
      className: 'TldLegalAgreement',
      modelProperties: {
        agreementKey: {
          required: false,
          serializedName: 'agreementKey',
          type: {
            name: 'String'
          }
        },
        title: {
          required: false,
          serializedName: 'title',
          type: {
            name: 'String'
          }
        },
        content: {
          required: false,
          serializedName: 'content',
          type: {
            name: 'String'
          }
        },
        url: {
          required: false,
          serializedName: 'url',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = TldLegalAgreement;
