/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the TopLevelDomain class.
 * @constructor
 * A top level domain object
 * @member {string} [topLevelDomainName] Name of the top level domain
 * 
 * @member {boolean} [privacy] If true then the top level domain supports
 * domain privacy
 * 
 */
function TopLevelDomain() {
  TopLevelDomain['super_'].call(this);
}

util.inherits(TopLevelDomain, models['Resource']);

/**
 * Defines the metadata of TopLevelDomain
 *
 * @returns {object} metadata of TopLevelDomain
 *
 */
TopLevelDomain.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'TopLevelDomain',
    type: {
      name: 'Composite',
      className: 'TopLevelDomain',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        location: {
          required: true,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        topLevelDomainName: {
          required: false,
          serializedName: 'properties.name',
          type: {
            name: 'String'
          }
        },
        privacy: {
          required: false,
          serializedName: 'properties.privacy',
          type: {
            name: 'Boolean'
          }
        }
      }
    }
  };
};

module.exports = TopLevelDomain;
