/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the VirtualNetworkProfile class.
 * @constructor
 * Specification for using a virtual network
 * @member {string} [id] Resource id of the virtual network
 * 
 * @member {string} [name] Name of the virtual network (read-only)
 * 
 * @member {string} [type] Resource type of the virtual network (read-only)
 * 
 * @member {string} [subnet] Subnet within the virtual network
 * 
 */
function VirtualNetworkProfile() {
}

/**
 * Defines the metadata of VirtualNetworkProfile
 *
 * @returns {object} metadata of VirtualNetworkProfile
 *
 */
VirtualNetworkProfile.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VirtualNetworkProfile',
    type: {
      name: 'Composite',
      className: 'VirtualNetworkProfile',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        subnet: {
          required: false,
          serializedName: 'subnet',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = VirtualNetworkProfile;
