/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the VnetGateway class.
 * @constructor
 * The VnetGateway contract. This is used to give the vnet gateway access to
 * the VPN package.
 * @member {string} [vnetName] The VNET name.
 * 
 * @member {string} [vpnPackageUri] The URI where the Vpn package can be
 * downloaded
 * 
 */
function VnetGateway() {
  VnetGateway['super_'].call(this);
}

util.inherits(VnetGateway, models['Resource']);

/**
 * Defines the metadata of VnetGateway
 *
 * @returns {object} metadata of VnetGateway
 *
 */
VnetGateway.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VnetGateway',
    type: {
      name: 'Composite',
      className: 'VnetGateway',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        location: {
          required: true,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        vnetName: {
          required: false,
          serializedName: 'properties.vnetName',
          type: {
            name: 'String'
          }
        },
        vpnPackageUri: {
          required: false,
          serializedName: 'properties.vpnPackageUri',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = VnetGateway;
