/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ApplicationPackageReference class.
 * @constructor
 * @summary A reference to an application package to be deployed to compute
 * nodes.
 *
 * @member {string} applicationId The id of the application to deploy.
 * 
 * @member {string} [version] The version of the application to deploy. If
 * omitted, the default version is deployed.
 * 
 */
function ApplicationPackageReference() {
}

/**
 * Defines the metadata of ApplicationPackageReference
 *
 * @returns {object} metadata of ApplicationPackageReference
 *
 */
ApplicationPackageReference.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ApplicationPackageReference',
    type: {
      name: 'Composite',
      className: 'ApplicationPackageReference',
      modelProperties: {
        applicationId: {
          required: true,
          serializedName: 'applicationId',
          type: {
            name: 'String'
          }
        },
        version: {
          required: false,
          serializedName: 'version',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ApplicationPackageReference;
