/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the ExitCodeMapping class.
 * @constructor
 * How the Batch service should respond if a task exits with a particular exit
 * code.
 *
 * @member {number} code A process exit code.
 * 
 * @member {object} exitOptions How the Batch service should respond if the
 * task exits with this exit code.
 * 
 * @member {string} [exitOptions.jobAction] An action to take on the job
 * containing the task, if the task completes with the given exit condition
 * and the job’s onTaskFailed property is 'performexitoptionsjobaction'.
 * Possible values include: 'none', 'disable', 'terminate'
 * 
 */
function ExitCodeMapping() {
}

/**
 * Defines the metadata of ExitCodeMapping
 *
 * @returns {object} metadata of ExitCodeMapping
 *
 */
ExitCodeMapping.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ExitCodeMapping',
    type: {
      name: 'Composite',
      className: 'ExitCodeMapping',
      modelProperties: {
        code: {
          required: true,
          serializedName: 'code',
          type: {
            name: 'Number'
          }
        },
        exitOptions: {
          required: true,
          serializedName: 'exitOptions',
          type: {
            name: 'Composite',
            className: 'ExitOptions'
          }
        }
      }
    }
  };
};

module.exports = ExitCodeMapping;
