/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the ExitCodeRangeMapping class.
 * @constructor
 * A range of exit codes and how the Batch service should respond to exit
 * codes within that range.
 *
 * @member {number} start The first exit code in the range.
 * 
 * @member {number} end The last exit code in the range.
 * 
 * @member {object} exitOptions An exitOptions specifying how the Batch
 * service should respond if the task exits with an exit code in the range
 * start to end.
 * 
 * @member {string} [exitOptions.jobAction] An action to take on the job
 * containing the task, if the task completes with the given exit condition
 * and the job’s onTaskFailed property is 'performexitoptionsjobaction'.
 * Possible values include: 'none', 'disable', 'terminate'
 * 
 */
function ExitCodeRangeMapping() {
}

/**
 * Defines the metadata of ExitCodeRangeMapping
 *
 * @returns {object} metadata of ExitCodeRangeMapping
 *
 */
ExitCodeRangeMapping.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ExitCodeRangeMapping',
    type: {
      name: 'Composite',
      className: 'ExitCodeRangeMapping',
      modelProperties: {
        start: {
          required: true,
          serializedName: 'start',
          type: {
            name: 'Number'
          }
        },
        end: {
          required: true,
          serializedName: 'end',
          type: {
            name: 'Number'
          }
        },
        exitOptions: {
          required: true,
          serializedName: 'exitOptions',
          type: {
            name: 'Composite',
            className: 'ExitOptions'
          }
        }
      }
    }
  };
};

module.exports = ExitCodeRangeMapping;
