/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ExitOptions class.
 * @constructor
 * How the Batch service should respond to a particular exit condition.
 *
 * @member {string} [jobAction] An action to take on the job containing the
 * task, if the task completes with the given exit condition and the job’s
 * onTaskFailed property is 'performexitoptionsjobaction'. Possible values
 * include: 'none', 'disable', 'terminate'
 * 
 */
function ExitOptions() {
}

/**
 * Defines the metadata of ExitOptions
 *
 * @returns {object} metadata of ExitOptions
 *
 */
ExitOptions.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ExitOptions',
    type: {
      name: 'Composite',
      className: 'ExitOptions',
      modelProperties: {
        jobAction: {
          required: false,
          serializedName: 'jobAction',
          type: {
            name: 'Enum',
            allowedValues: [ 'none', 'disable', 'terminate' ]
          }
        }
      }
    }
  };
};

module.exports = ExitOptions;
