/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the NetworkConfiguration class.
 * @constructor
 * The network configuration for a pool.
 *
 * @member {string} [subnetId] The ARM resource identifier of the virtual
 * network subnet which the compute nodes of the pool will join. The virtual
 * network must be in the same region and subscription as the Azure Batch
 * account. This property can only be specified for pools created with a
 * cloudServiceConfiguration.
 * 
 */
function NetworkConfiguration() {
}

/**
 * Defines the metadata of NetworkConfiguration
 *
 * @returns {object} metadata of NetworkConfiguration
 *
 */
NetworkConfiguration.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'NetworkConfiguration',
    type: {
      name: 'Composite',
      className: 'NetworkConfiguration',
      modelProperties: {
        subnetId: {
          required: false,
          serializedName: 'subnetId',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = NetworkConfiguration;
