/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the TaskUpdateParameter class.
 * @constructor
 * @summary Parameters for a CloudTaskOperations.Update request.
 *
 * @member {object} [constraints] Constraints that apply to this task. If
 * omitted, the task is given the default constraints.
 * 
 * @member {moment.duration} [constraints.maxWallClockTime]
 * 
 * @member {moment.duration} [constraints.retentionTime] The default is
 * infinite.
 * 
 * @member {number} [constraints.maxTaskRetryCount]
 * 
 */
function TaskUpdateParameter() {
}

/**
 * Defines the metadata of TaskUpdateParameter
 *
 * @returns {object} metadata of TaskUpdateParameter
 *
 */
TaskUpdateParameter.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'TaskUpdateParameter',
    type: {
      name: 'Composite',
      className: 'TaskUpdateParameter',
      modelProperties: {
        constraints: {
          required: false,
          serializedName: 'constraints',
          type: {
            name: 'Composite',
            className: 'TaskConstraints'
          }
        }
      }
    }
  };
};

module.exports = TaskUpdateParameter;
