/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the CertificateIssuerListResult class.
 * @constructor
 * The certificate issuer list result
 * @member {array} [value] A response message containing a list of certificate
 * issuers in the vault along with a link to the next page of certificate
 * issuers
 * 
 * @member {string} [nextLink] The URL to get the next set of certificate
 * issuers.
 * 
 */
function CertificateIssuerListResult() {
}

util.inherits(CertificateIssuerListResult, Array);

/**
 * Defines the metadata of CertificateIssuerListResult
 *
 * @returns {object} metadata of CertificateIssuerListResult
 *
 */
CertificateIssuerListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'CertificateIssuerListResult',
    type: {
      name: 'Composite',
      className: 'CertificateIssuerListResult',
      modelProperties: {
        value: {
          required: false,
          readOnly: true,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'CertificateIssuerItemElementType',
                type: {
                  name: 'Composite',
                  className: 'CertificateIssuerItem'
                }
            }
          }
        },
        nextLink: {
          required: false,
          readOnly: true,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = CertificateIssuerListResult;
