/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the CertificateIssuerSetParameters class.
 * @constructor
 * The certificate issuer set parameters.
 *
 * @member {string} provider The issuer provider.
 * 
 * @member {object} [credentials] The credentials to be used for the issuer.
 * 
 * @member {string} [credentials.accountId] The user name/account name/account
 * id.
 * 
 * @member {string} [credentials.password] The password/secret/account key.
 * 
 * @member {object} [organizationDetails] Details of the organization as
 * provided to the issuer.
 * 
 * @member {string} [organizationDetails.id] Id of the organization.
 * 
 * @member {array} [organizationDetails.adminDetails] Details of the
 * organization administrator.
 * 
 * @member {object} [attributes] Attributes of the issuer object.
 * 
 * @member {boolean} [attributes.enabled] Determines whether the issuer is
 * enabled
 * 
 * @member {date} [attributes.created] Creation time in UTC
 * 
 * @member {date} [attributes.updated] Last updated time in UTC
 * 
 */
function CertificateIssuerSetParameters() {
}

/**
 * Defines the metadata of CertificateIssuerSetParameters
 *
 * @returns {object} metadata of CertificateIssuerSetParameters
 *
 */
CertificateIssuerSetParameters.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'CertificateIssuerSetParameters',
    type: {
      name: 'Composite',
      className: 'CertificateIssuerSetParameters',
      modelProperties: {
        provider: {
          required: true,
          serializedName: 'provider',
          type: {
            name: 'String'
          }
        },
        credentials: {
          required: false,
          serializedName: 'credentials',
          type: {
            name: 'Composite',
            className: 'IssuerCredentials'
          }
        },
        organizationDetails: {
          required: false,
          serializedName: 'org_details',
          type: {
            name: 'Composite',
            className: 'OrganizationDetails'
          }
        },
        attributes: {
          required: false,
          serializedName: 'attributes',
          type: {
            name: 'Composite',
            className: 'IssuerAttributes'
          }
        }
      }
    }
  };
};

module.exports = CertificateIssuerSetParameters;
