/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the KeyItem class.
 * @constructor
 * The key item containing key metadata
 *
 * @member {string} [kid] Key Identifier
 * 
 * @member {object} [attributes] The key management attributes
 * 
 * @member {object} [tags] Application-specific metadata in the form of
 * key-value pairs
 * 
 * @member {boolean} [managed] True if the key's lifetime is managed by key
 * vault i.e. if this is a key backing a certificate, then managed will be
 * true.
 * 
 */
function KeyItem() {
}

/**
 * Defines the metadata of KeyItem
 *
 * @returns {object} metadata of KeyItem
 *
 */
KeyItem.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'KeyItem',
    type: {
      name: 'Composite',
      className: 'KeyItem',
      modelProperties: {
        kid: {
          required: false,
          serializedName: 'kid',
          type: {
            name: 'String'
          }
        },
        attributes: {
          required: false,
          serializedName: 'attributes',
          type: {
            name: 'Composite',
            className: 'KeyAttributes'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        managed: {
          required: false,
          readOnly: true,
          serializedName: 'managed',
          type: {
            name: 'Boolean'
          }
        }
      }
    }
  };
};

module.exports = KeyItem;
