/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the KeyProperties class.
 * @constructor
 * Properties of the key pair backing a certificate.
 *
 * @member {boolean} [exportable] Indicates if the private key can be exported.
 * 
 * @member {string} [keyType] The key type.
 * 
 * @member {number} [keySize] The key size in bytes. e.g. 2048.
 * 
 * @member {boolean} [reuseKey] Indicates if the same key pair will be used on
 * certificate renewal.
 * 
 */
function KeyProperties() {
}

/**
 * Defines the metadata of KeyProperties
 *
 * @returns {object} metadata of KeyProperties
 *
 */
KeyProperties.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'KeyProperties',
    type: {
      name: 'Composite',
      className: 'KeyProperties',
      modelProperties: {
        exportable: {
          required: false,
          serializedName: 'exportable',
          type: {
            name: 'Boolean'
          }
        },
        keyType: {
          required: false,
          serializedName: 'kty',
          type: {
            name: 'String'
          }
        },
        keySize: {
          required: false,
          serializedName: 'key_size',
          type: {
            name: 'Number'
          }
        },
        reuseKey: {
          required: false,
          serializedName: 'reuse_key',
          type: {
            name: 'Boolean'
          }
        }
      }
    }
  };
};

module.exports = KeyProperties;
