/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the KeyUpdateParameters class.
 * @constructor
 * The key update parameters
 *
 * @member {array} [keyOps] Json web key operations. For more information on
 * possible key operations, see JsonWebKeyOperation.
 * 
 * @member {object} [keyAttributes]
 * 
 * @member {object} [tags] Application-specific metadata in the form of
 * key-value pairs
 * 
 */
function KeyUpdateParameters() {
}

/**
 * Defines the metadata of KeyUpdateParameters
 *
 * @returns {object} metadata of KeyUpdateParameters
 *
 */
KeyUpdateParameters.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'KeyUpdateParameters',
    type: {
      name: 'Composite',
      className: 'KeyUpdateParameters',
      modelProperties: {
        keyOps: {
          required: false,
          serializedName: 'key_ops',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        keyAttributes: {
          required: false,
          serializedName: 'attributes',
          type: {
            name: 'Composite',
            className: 'KeyAttributes'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = KeyUpdateParameters;
