/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the LifetimeAction class.
 * @constructor
 * Action and its trigger that will be performed by Key Vault over the
 * lifetime of a certificate.
 *
 * @member {object} [trigger] The condition that will execute the action.
 * 
 * @member {number} [trigger.lifetimePercentage] Percentage of lifetime as
 * which to trigger. Value should be between 1 and 99.
 * 
 * @member {number} [trigger.daysBeforeExpiry] Days before expiry.
 * 
 * @member {object} [action] The action that will be executed.
 * 
 * @member {string} [action.actionType] The type of the action. Possible
 * values include: 'EmailContacts', 'AutoRenew'
 * 
 */
function LifetimeAction() {
}

/**
 * Defines the metadata of LifetimeAction
 *
 * @returns {object} metadata of LifetimeAction
 *
 */
LifetimeAction.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'LifetimeAction',
    type: {
      name: 'Composite',
      className: 'LifetimeAction',
      modelProperties: {
        trigger: {
          required: false,
          serializedName: 'trigger',
          type: {
            name: 'Composite',
            className: 'Trigger'
          }
        },
        action: {
          required: false,
          serializedName: 'action',
          type: {
            name: 'Composite',
            className: 'Action'
          }
        }
      }
    }
  };
};

module.exports = LifetimeAction;
