/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the SecretItem class.
 * @constructor
 * The secret item containing secret metadata
 *
 * @member {string} [id] Secret Identifier
 * 
 * @member {object} [attributes] The secret management attributes
 * 
 * @member {object} [tags] Application-specific metadata in the form of
 * key-value pairs
 * 
 * @member {string} [contentType] Type of the secret value such as a password
 * 
 * @member {boolean} [managed] True if the secret's lifetime is managed by key
 * vault i.e. if this is a key backing a certificate, then managed will be
 * true.
 * 
 */
function SecretItem() {
}

/**
 * Defines the metadata of SecretItem
 *
 * @returns {object} metadata of SecretItem
 *
 */
SecretItem.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SecretItem',
    type: {
      name: 'Composite',
      className: 'SecretItem',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        attributes: {
          required: false,
          serializedName: 'attributes',
          type: {
            name: 'Composite',
            className: 'SecretAttributes'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        contentType: {
          required: false,
          serializedName: 'contentType',
          type: {
            name: 'String'
          }
        },
        managed: {
          required: false,
          readOnly: true,
          serializedName: 'managed',
          type: {
            name: 'Boolean'
          }
        }
      }
    }
  };
};

module.exports = SecretItem;
