/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the SubjectAlternativeNames class.
 * @constructor
 * The subject alternate names of a X509 object.
 *
 * @member {array} [emails] Email addresses.
 * 
 * @member {array} [dnsNames] Domain names.
 * 
 * @member {array} [upns] User principal names.
 * 
 */
function SubjectAlternativeNames() {
}

/**
 * Defines the metadata of SubjectAlternativeNames
 *
 * @returns {object} metadata of SubjectAlternativeNames
 *
 */
SubjectAlternativeNames.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SubjectAlternativeNames',
    type: {
      name: 'Composite',
      className: 'SubjectAlternativeNames',
      modelProperties: {
        emails: {
          required: false,
          serializedName: 'emails',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        dnsNames: {
          required: false,
          serializedName: 'dns_names',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        upns: {
          required: false,
          serializedName: 'upns',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = SubjectAlternativeNames;
