#!/bin/bash

command -v node > /dev/null 2>&1 || { echo >&2 "You don't have node.js installed."; return 1; }
if [ $(node -v | cut -c 1-2) != "v4" ]; then
  echo >&2 "You have the wrong version of node.js installed. The version 4 is recommended."
fi

CURRENT_DIR=$(pwd)
SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
cd "${SCRIPT_DIR}"
rm dev.tar.gz
wget https://github.com/Azure/azure-xplat-cli/archive/dev.tar.gz
tar -xf dev.tar.gz
rm dev.tar.gz
cd azure-xplat-cli-dev
CLI_DIR=$(pwd)
npm install
FABRIC_CODE_DIR="$(dirname $(dirname $(dirname ${SCRIPT_DIR})))/build.prod/FabricDrop/bin/Fabric/Fabric.Code"
export SERVICE_FABRIC_DEVELOPER=true
export SERVICE_FABRIC_CODE_PATH=${FABRIC_CODE_DIR}
sudo ln -sf "${CLI_DIR}/bin/azure" /usr/local/bin/azuresfcli
cd $CURRENT_DIR

